      integer   nchan, ndata, nfreq, lin, ist(5,8), nc, ichan, icomp
      integer   numfre, alin, if, nsites, isite, j, lout, nsts, ifr
      integer   cist(8), np, nsides, i, nhist, refchn
      parameter( nfreq = 64, ndata = 3, nchan = 8, alin = 99, lin = 1 )
      parameter( lout = 98 )
      integer   ind(nfreq), ifind, ntfr, notch, cal, nstack, mstack
      real      dat(nchan,ndata,nfreq), current(nfreq)
      real      fre(nfreq), err(nchan,ndata,nfreq)
      real      data(nfreq,nchan,ndata), freq(nfreq)
      real      errs(nfreq,nchan,ndata), diplen, lgt(nchan)
      real      posx(8), posy(8), posz(8), azimut(8), resist(8)
      real      decl, gain, tx(10), ty(10), tz(10)
      character ifile*70, chan(8)*3, hist(20)*60
      character proj*10, alfile*70, rhoa(5)*5
      logical   fend
      data      chan/'Ex1','Ey1','Ex1','Ex1','Ex1','Hz1','Hx1','Hy1'/
      data      decl/-20.0/, ntfr/0/
      data      proj/'lem'/, alfile/'gscgasp.ctl'/
      data      rhoa/'Ex/Hy','Ey/Hx','Hx/Hy','Hy/Hy','Hz/Hy'/
c
      call tin('Name of survey control file ?',alfile)
      call tin('Root name for project ?',proj)
      call rin('Effective declination (if not set in field) ?',decl)
      call trunc(proj,np)
      open(unit=alin,file=alfile,status='old',err=3000)
      read(alin,*) nsides
      do i = 1, nsides+1
        read(alin,*) ty(i), tx(i), tz(i)
      end do
1100  call get(alin,ifile,*1000,*2000)
c
      open(unit=lin,file=ifile,status='unknown')
      ifr = 1
      call rdddu(lin,6,nchan,ndata,nfreq,numfre,fre,ifr,
     >           notch,cal,nstack,mstack,diplen,dat,err,gain,
     >           current,chan,refchn,fend)
      call rdddu(lin,6,nchan,ndata,nfreq,numfre,fre,ifr,
     >           notch,cal,nstack,mstack,diplen,dat,err,gain,
     >           current,chan,refchn,fend)
      read(alin,*) nsites
      do isite = 1, nsites
        read(alin,*) cist(isite), (ist(j,isite), j = 1, 5)
      end do
      do ichan = 1, nchan
        read(alin,*) icomp, posy(ichan), posx(ichan), posz(ichan), 
     >               azimut(ichan), resist(ichan), lgt(ichan)
        azimut(ichan) = azimut(ichan) + decl
      end do
      call sort(nfreq,numfre,fre,ind)
      do if = 1, numfre
        ifind = ind(if)
        freq(if) = fre(ifind)
        do ichan = 1, 8
          if(lgt(ichan).eq.0.0) then
            dat(ichan,1,ifind) = dat(ichan,1,ifind)*7.9577e-04
           else
            dat(ichan,1,ifind) = dat(ichan,1,ifind)/lgt(ichan)
          end if
          dat(ichan,1,ifind) = dat(ichan,1,ifind)/1000.0
        end do
        do ichan = 1, 8
          data(if,ichan,1) = dat(ichan,1,ifind)
          errs(if,ichan,1) = 0.01*err(ichan,1,ifind)*
     >                            abs(data(if,ichan,1))
          data(if,ichan,2) = dat(ichan,2,ifind)
          errs(if,ichan,2) = 0.01*err(ichan,2,ifind)*
     >                            abs(data(if,ichan,2))
c
c Make the phase always relative to H_y
c
          data(if,ichan,3) = dat(ichan,3,ifind) - dat(ist(4,1),3,ifind)
          errs(if,ichan,3) = err(ichan,3,ifind) + err(ist(4,1),3,ifind)
        end do
      end do

c Output the data
c
      call trunc(proj,np)
      nhist = 1
      call trunc(ifile,nc)
      hist(1) = 'Translated from file '//ifile(1:nc)
      nsts = 1
      call output(lout,nsts,nsides,tx,ty,tz,nfreq,nchan,ndata,
     >            numfre,chan,rhoa,posx,posy,posz,azimut,lgt,resist,
     >            freq,data,errs,ist,nhist,hist,cist,proj,np)
      goto 1100
c
      stop
1000  write(*,*) 'End of file found'
      stop
2000  write(*,*) 'Error reading input file'
      stop
3000  write(*,*) 'Error opening input file'
      stop
      end
c--------------------------------------------------------------------------
      subroutine get(lun,string,*,*)
c--------------------------------------------------------------------------
      character string*100
      integer   lun, nchar
c
3000  read(lun,'(a100)',end=1000,err=2000) string
      call trunc(string,nchar)
      if(nchar.eq.0) goto 3000
      return
1000  return 1
2000  return 2
      end
c------------------------------------------------------------------------
      subroutine rdddu(lin,lout,nchan,ndata,nfreq,numfre,freq,ifr,
     >                 notch,cal,nstack,mstack,diplen,data,errors,gain,
     >                 current,chan,refchn,fend)
c------------------------------------------------------------------------
      character string*70, date*7, time*8
      character survey*70, site*70, description*70, chan(8)*3
      integer   lin, lout, nchan, ndata, nfreq, ilen, ifreq, notch
      integer   nstack, mstack, refchn, numfre, if2, cal
      integer   idata, altfre, i, nchar, ichan, ifr
      real      current(nfreq), diplen
      real      data(nchan,ndata,nfreq)
      real      errors(nchan,ndata,nfreq)
      real      gain, freq(nfreq)
      logical   fend
c
      read(lin,'(a70)',err=2000) string
      ilen = index(string,'=') 
      string = string(ilen+1:)
      if(ilen.ne.0) write(lout,10) string(1:5)
10    format(' Reading Record Number : ',a5)
      read(lin,'(a7)',err=2000) date
      fend = .false.
      if(date(1:4).eq.'END$') then 
        write(lout,14)
14      format(/,20x,'<..... End of data file found .....>',/)
        numfre = ifr - 1 
        fend = .true.
        return
      end if
      read(lin,'(a70)',err=2000) string
      write(lout,11) string(1:50)
11    format(' File designator       : ',a50)
      read(lin,'(a7)',err=2000) date
      read(lin,'(a8)',err=2000) time
      write(lout,12) time,date
12    format(' Data from ',a8,' on ',a7)
      read(lin,'(a70)',err=2000) survey
      read(lin,'(a70)',err=2000) description
      read(lin,'(a70)',err=2000) site
      do 1000 i = 1, 3
        read(lin,'(a70)',err=2000) string
        write(lout,*) string
1000  continue
      read(lin,'(a70)',err=2000) string
      call getchn(string,chan)
c
      read(lin,*,err=2000) refchn
      read(lin,*,err=2000) diplen
      do ifreq = 1, nfreq
        read(lin,'(a70)',err=1001, end=1001) string
        if(string(1:4).eq.'END$') then 
          write(lout,13) 
  13      format(20x,'+----> Proper end of data set found',/)
          numfre = ifr - 1
          read(lin,'(a1)') string(1:1)
          return
         else
          call trunc(string,nchar)
          if(nchar.eq.1) read(string,'(i1)') if2
          if(nchar.eq.2) read(string,'(i2)') if2
        end if
        freq(ifr) = 2.0**if2
        read(lin,*,err=2000) notch
        read(lin,*,err=2000) cal
        read(lin,*,err=2000) altfre
        if(altfre.ne.0) freq(ifr) = 2.0*freq(ifr)/3.0
        read(lin,*,err=2000) nstack
        read(lin,*,err=2000) mstack
c 
c Read over the number of channels, and then the number of data
c The number of data is usually three - field/apparent resistivity/phase
c
        do 1002 ichan = 1, nchan
          do 1003 idata = 1, ndata
            read(lin,*,err=2000) errors(ichan,idata,ifr)
1003      continue
          read(lin,*,err=2000) gain
1002    continue
        read(lin,*,err=2000) current(ifr)
        current(ifr) = current(ifr)/1000.0
        write(6,*) freq(ifr), current(ifr)
        if(current(ifr).eq.0.0) then 
          current(ifr) = 1.0
          write(*,*) 'WARNING -- missing current value @ freq ',ifr
          write(*,*) 'Assuming a value of 1.0 for the Tx current'
        end if
        do 1004 ichan = 1, nchan
          do 1005 idata = 1, ndata
            read(lin,*,err=2000) data(ichan,idata,ifr)
            if(idata.eq.1) data(ichan,idata,ifr) =
     >                     data(ichan,idata,ifr)/current(ifr)
1005      continue
1004    continue
        ifr = ifr + 1
      end do
1001  read(lin,'(a1)') string(1:1)
 
      return
2000  write(*,*) 'ERROR in reading input data file'//char(7)
      numfre = 0
      fend = .true.
      return
      end
